<?php
if(!isset($_SESSION)) 
    { 
        //session_start(); 
    }

$pluginsurl = plugins_url( '', __FILE__ );

$wccp_pro_settings = wccp_pro_read_options();

function wccp_pro_save_setting($name, $default_value)
{
	$wccp_pro_settings = wccp_pro_read_options();
	
	if (!array_key_exists("$name",$wccp_pro_settings) && !isset( $_POST['Save_settings'] ) && isset( $_POST['Restore_defaults'] )) //Restore defaults
	{
		if(!(isset($_POST["make_this_form_verified_nonce"]) && wp_verify_nonce( $_POST[ 'make_this_form_verified_nonce' ], 'make_form_nonce_action' ))) return; //Exit if not verified
		
		$option_new_value = $default_value;
		
		$wccp_pro_settings["$name"] = $option_new_value;
		
		update_blog_option_single_and_multisite( 'wccp_pro_settings' , $wccp_pro_settings );
	}
	
	if (!array_key_exists("$name",$wccp_pro_settings) && !isset( $_POST['Save_settings'] ) && !isset( $_POST['Restore_defaults'] )) //Option saved with default value after first activation
	{
		$option_new_value = $default_value;
		
		$wccp_pro_settings["$name"] = $option_new_value;
		
		update_blog_option_single_and_multisite( 'wccp_pro_settings' , $wccp_pro_settings );
	}
	
	if(isset( $_POST['Save_settings'] )) //Save settings
	{
		if(!(isset($_POST["make_this_form_verified_nonce"]) && wp_verify_nonce( $_POST[ 'make_this_form_verified_nonce' ], 'make_form_nonce_action' ))) return; //Exit if not verified
		
		$wccp_pro_settings = wccp_pro_read_options();
		
		$option_new_value = '';
		
		$incoming_value = '';
		
		if(isset($wccp_pro_settings["$name"])) $incoming_value = $wccp_pro_settings["$name"]; else $incoming_value = '';
		
		if(isset($_POST["$name"])) $option_new_value = $_POST["$name"]; //if posted take it
		
		if (!isset($_POST["$name"]) && $incoming_value != '') $option_new_value = ''; //if (not posted & stored before) then clear it
		
		if(!isset($_POST["$name"]) && $incoming_value == 'checked') $option_new_value = '';
		
		$wccp_pro_settings["$name"] = $option_new_value;
		
		update_blog_option_single_and_multisite( 'wccp_pro_settings' , $wccp_pro_settings );
		
		$wccp_pro_settings = wccp_pro_read_options();
	}
}

function update_blog_option_single_and_multisite($option,$value)
{
	if(is_multisite())
	{
		$id = get_current_blog_id();
		update_blog_option($id, $option,$value);
	}
	else
	{
		update_option($option,$value);
	}
}

function get_blog_option_single_and_multisite($option = '')
{
	if(is_multisite())
	{
		$id = get_current_blog_id();
		return get_blog_option($id, $option);
	}
	else
	{
		return get_option($option);
	}
}

//---------------------------------------------------------------------------------------------
//Function to read options from the database
//---------------------------------------------------------------------------------------------
function wccp_pro_read_options()
{
	if (get_blog_option_single_and_multisite('wccp_pro_settings'))
		$wccp_pro_settings = get_blog_option_single_and_multisite('wccp_pro_settings');
	else
		$wccp_pro_settings = array();
	
	$defaults_array = array('single_posts_protection' => '',"home_page_protection" => 'checked','page_protection' => 'checked',
	'smessage' => 'checked','ctrl_message' => 'checked','prntscr_protection' => 'checked','drag_drop' => 'checked','drag_drop_images' => 'checked','ctrl_p_protection' => 'checked',
	'ctrl_s_protection' => 'checked','ctrl_a_protection' => 'checked','ctrl_c_protection' => 'checked','ctrl_x_protection' => 'checked',
	'ctrl_v_protection' => 'checked','ctrl_u_protection' => 'checked','f12_protection' => 'checked','custom_keys_message' => 'You are not allowed to do this action on the current page!!',
	'prnt_scr_msg' => 'Protected' ,'msg_color' => '','font_color' => '','msg_font_size' => '','border_color' => '','shadow_color' => '',
	'message_show_time' => 3,'right_click_protection_posts' => 'checked','right_click_protection_homepage' => "checked",
	'right_click_protection_pages' => "checked",'img' => "checked", 'a' => "checked", 'pb' => "checked",
	'h' => "checked",'textarea' => "checked", 'input' => "checked", 'emptyspaces' => "checked",
	'videos' => "", 'alert_msg_img' => "Alert: Protected image", 'alert_msg_a' => "Alert: This link is protected",
	'alert_msg_pb' => "Alert: Right click on text is disabled",
	'alert_msg_h' => "Alert: Right click on headlines is disabled",
	'alert_msg_textarea' => "Alert: Right click is disabled",
	'alert_msg_input' => "Alert: Right click is disabled",
	'alert_msg_emptyspaces' => "Alert: Right click on empty spaces is disabled",
	'alert_msg_videos' => "Alert: Right click on videos is disabled",
	'home_css_protection' => "Yes", 'posts_css_protection' => "Yes", 'pages_css_protection' => "Yes",
	'custom_css_code' => "", 'protection_overlay_posts' =>"", 'protection_overlay_homepage' =>"",
	'protection_overlay_pages' =>"", 'remove_img_urls' => "No", 'no_js_action' => "Nothing",'no_js_action_massage' => "You can not open this website with JS disabled!!",'watermark_caching' => 'checked',
	'hotlinking_rule' => "Watermark", 'mysite_rule' => "Watermark", 'dw_logo' => "", 'dw_margin_top_factor' => 98,
	'dw_margin_left_factor' => 98, 'dw_text' => "WATERMARKED", 'dw_font_color' => "#000000",
	'dw_position' => "center-center", 'dw_font_size_factor' => 90, 'dw_r_text' => "www.mywebsite.com",
	'dw_r_font_color' => "#efefef", 'dw_r_font_size_factor' => 55, 'dw_text_transparency' => 65, 'dw_rotation' => 40,
	'dw_imagefilter' => "None", 'dw_signature' => "This image is protected", 'url_exclude_list' =>"","exclude_registered_images_sizes"=>"150x150",
	"excluded_images_from_watermarking"=>"logo,150x150",'selection_exclude_classes' =>"", 'exclude_online_services' =>"",
	"url_included_list" => "","do_not_use_cookies" => "", "opposite_mode" => "Inactive",
	'exclude_by_user_type' => "",'exclude_by_post_type' => "",'exclude_by_category' => "", 'show_admin_bar_icon' => "Yes",'developer_mode' => "No", 'kill_devlop_tools' => "", 'kill_browsers_extensions' => "");

	foreach ($wccp_pro_settings as $key=>$value)
	{
		if(is_string($value))$wccp_pro_settings[$key] = stripslashes($value);
		if(is_array($value))$wccp_pro_settings[$key] = $value;
	}
	
	if (isset($_GET['page']))
	{
		if($_GET['page'] != 'wccp-options-pro') //We don't want this merge to work inside plugin admin panel
		{
			$wccp_pro_settings = array_merge($defaults_array, $wccp_pro_settings);//Set default value for any unexisted key
		}
	}
	else
	{
		$wccp_pro_settings = array_merge($defaults_array, $wccp_pro_settings);//Set default value for any unexisted key
	}
	
	return $wccp_pro_settings;

}
////////////////////////////////////////////////////////////////////////

function wccp_pro_remove_img_urls_with_js()// remove direct links from images
{
	global $wccp_pro_settings;
	
	if($wccp_pro_settings["remove_img_urls"] == "Yes")
	{
	?>
		<script>
			jQuery(document).ready(function()
			{
				jQuery("a:has(img)").each(function()
				{
					var attr_href = jQuery(this).attr("href");
					
					if (attr_href.endsWith("jpg") || attr_href.endsWith("png") || attr_href.endsWith("gif") || attr_href.endsWith("webp") || attr_href.endsWith("bmp"))
					{
						jQuery(this).replaceWith(jQuery(this).children());
					}
				});
				
			});
		</script>
	<?php
	}
}
add_action('wp_head','wccp_pro_remove_img_urls_with_js');
////////////////////////////////////////////////////////////////////////
function wccp_pro_add_style() {
	global $wccp_pro_pluginsurl;
	echo '<link rel="stylesheet" id="wccp_pro_add_style"  href="'.$wccp_pro_pluginsurl.'/hide-saving.css" type="text/css" media="all" />';
}
////////////////////////////////////////////////////////////////////////
function get_selection_exclude_classes()
{
	global $wccp_pro_settings;

	$selection_exclude_classes = '';

	if ( isset( $wccp_pro_settings['selection_exclude_classes'] ) ) 
	{
		$selection_exclude_classes = $wccp_pro_settings['selection_exclude_classes'];
	}

	// Processes \r\n's first so they aren't converted twice.
	$selection_exclude_classes = str_replace("\\n", "\n", $selection_exclude_classes);

	$selection_exclude_classes = str_replace("\n", ",", $selection_exclude_classes);

	$selection_exclude_classes = str_replace("\r", ",", $selection_exclude_classes);

	$selection_exclude_classes = str_replace("|", ",", $selection_exclude_classes);

	$selection_exclude_classes = str_replace(",,", ",", $selection_exclude_classes);
	
	return $selection_exclude_classes;
}
////////////////////////////////////////////////////////////////////////
function get_role_names() {

global $wp_roles;

if ( ! isset( $wp_roles ) ) $wp_roles = new WP_Roles();

	$available_roles_names = $wp_roles->get_names();//we get all roles names

    $available_roles = array();
	$count = 0;
    foreach ($available_roles_names as $role_key => $role_name)
	{
        $available_roles[$count][0] = strtolower($role_key); //we populate the array of capable roles
		$available_roles[$count][1] = translate_user_role( $role_name );
		$count++;
    }
return $available_roles;
}
////////////////////////////////////////////////////////////////////////
function get_registered_images_sizes() {

	global $_wp_additional_image_sizes; 

	$available_sizes = array();
	$count = 0;
	foreach ($_wp_additional_image_sizes as $size)
	{
		$available_sizes[$count][0] = $size[ 'width' ] . "x" . $size[ 'height' ]; //we populate the array of capable roles
		$available_sizes[$count][1] = $available_sizes[$count][0];
		$count++;
	}
return $available_sizes;
}
////////////////////////////////////////////////////////////////////////
function wccp_pro_global_js_scripts()
{
	global $wccp_pro_settings;

	$selection_exclude_classes = get_selection_exclude_classes();
?>
<script id="wccp_pro_class_exclusion" type="text/javascript">
function copyToClipboard(elem) {
	  // create hidden text element, if it doesn't already exist
    var targetId = "_wccp_pro_hiddenCopyText_";
    {
        // must use a temporary form element for the selection and copy
        target = document.getElementById(targetId);
        if (!target) {
            var target = document.createElement("textarea");
            target.style.position = "absolute";
            target.style.left = "-9999px";
            target.style.top = "0";
            target.id = targetId;
            document.body.appendChild(target);
        }
        target.textContent = elem.textContent;
    }
    // select the content
    var currentFocus = document.activeElement;
    target.focus();
    target.setSelectionRange(0, target.value.length);
    
    // copy the selection
    var succeed;
    try {
    	  succeed = document.execCommand("copy");
    } catch(e) {
        succeed = false;
    }

    // restore original focus
    if (currentFocus && typeof currentFocus.focus === "function") {
        currentFocus.focus();
    }
    
    
	// clear temporary content
	target.textContent = "";
	document.getElementsByTagName('span')[0].innerHTML = " ";
    return succeed;
}
/**************************************************/
function wccp_pro_log_to_console_if_allowed(title = "title", data = "")
{
	<?php
	global $wccp_pro_settings;
	
	if(array_key_exists("developer_mode", $wccp_pro_settings))
	{	
		if($wccp_pro_settings['developer_mode'] == "Yes")
		{
		?>
			if(data != "" ) console.log(title + ": " + data);
		<?php
		}
	}
	?>
}
/**************************************************/
function fallbackCopyTextToClipboard(text) {
  var textArea = document.createElement("textarea");
  textArea.value = text;
  document.body.appendChild(textArea);
  textArea.focus();
  textArea.select();

  try {
    var successful = document.execCommand("copy");
    var msg = successful ? "successful" : "unsuccessful";
    console.log("Fallback: Copying text command was " + msg);
  } catch (err) {
    console.error("Fallback: Oops, unable to copy", err);
  }

  document.body.removeChild(textArea);
}
/*****************************************/
function copyTextToClipboard(text) {
  if (!navigator.clipboard) {
    fallbackCopyTextToClipboard(text);
    return;
  }
  navigator.clipboard.writeText(text).then(
    function() {
      console.log("Async: Copying to clipboard was successful!");
    },
    function(err) {
      console.error("Async: Could not copy text: ", err);
    }
  );
}
/*****************************************/
/*getSelectionTextAndContainerElement*/
function getSelectionTextAndContainerElement()
{
    var text = "", containerElement = null;
    if (typeof window.getSelection != "undefined") {
        var sel = window.getSelection();
        if (sel.rangeCount) {
            var node = sel.getRangeAt(0).commonAncestorContainer;
            containerElement = node.nodeType == 1 ? node : node.parentNode;
            text = sel.toString();
        }
    } else if (typeof document.selection != "undefined" && document.selection.type != "Control")
	{
        var textRange = document.selection.createRange();
        containerElement = textRange.parentElement();
        text = textRange.text;
    }
    return {
        text: text,
        containerElement: containerElement
    };
	console.log(containerElement);
}

function getSelectionParentElement() {
    var parentEl = null, sel;
	
    if (window.getSelection) {
        sel = window.getSelection();
        if (sel.rangeCount) {
            parentEl = sel.getRangeAt(0).commonAncestorContainer;
			//sel.getRangeAt(0).startContainer.parentNode;
            if (parentEl.nodeType != 1) {
                parentEl = parentEl.parentNode;
            }
        }
    } else if ( (sel = document.selection) && sel.type != "Control") {
        parentEl = sel.createRange().parentElement();
    }
	
	let arr = new Array();
	
	arr["nodeName"] = "cant_find_parent_element";
	
	if(parentEl != null)
		return parentEl;
	else
		return arr;
}
/*****************************************/
function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}
/*****************************************/
</script>

<script id="wccp_pro_class_exclusion" type="text/javascript">
function apply_class_exclusion(e)
{
	var my_return = 'No';
	
	var e = e || window.event; // also there is no e.target property in IE. instead IE uses window.event.srcElement
  	
	var target = e.target || e.srcElement || 'nothing';
	
	//if(target.parentElement != null) console.log (target.parentElement.className);
	
	var excluded_classes = '<?php echo $selection_exclude_classes; ?>' + '';
	
	var class_to_exclude = "";
	
	if(target.parentElement != null)
	{
		class_to_exclude = target.className + ' ' + target.parentElement.className || '';
	}else{
		class_to_exclude = target.className;
	}
	
	var class_to_exclude_array = class_to_exclude.split(" ");
	
	//console.log (class_to_exclude_array);
	
	class_to_exclude_array.forEach(function(item)
	{
		if(item != '' && excluded_classes.indexOf(item)>=0)
		{
			target.style.cursor = "text";
			
			console.log ('Yes');
			
			my_return = 'Yes';
		}
	});

	try {
		class_to_exclude = target.parentElement.getAttribute('class') || target.parentElement.className || '';
		}
	catch(err) 
		{
		class_to_exclude = '';
		}
	
	if(class_to_exclude != '' && excluded_classes.indexOf(class_to_exclude)>=0)
	{
		target.style.cursor = "text";
		my_return = 'Yes';
	}

	return my_return;
}
</script>
<?php
}
?>
<?php
////////////////////////////////////////////////////////////////////////
function wccp_pro_alert_message()
{
	global $wccp_pro_settings;
?>
	<div oncontextmenu="return false;" id='wccp_pro_mask'></div>
	<div id="wpcp-error-message" class="msgmsg-box-wpcp hideme"><span>error: </span><?php echo $wccp_pro_settings['smessage'];?></div>
	<script id="wccp_pro_alert_message" type="text/javascript">
	var timeout_result;
	function show_wccp_pro_message(smessage="", style="")
	{
		wccp_pro_log_to_console_if_allowed("function", "show_wccp_pro_message" + smessage);
		<?php
		$timeout = $wccp_pro_settings['message_show_time'] * 1000;
		
		if (isset($_GET['page']))
		{
			$admincore = $_GET['page'];
			
			if($admincore == 'wccp-options-pro') $timeout = 4000;
		}
		?>
		
		timeout = <?php echo $timeout;?>;
		
		if(style == "") style = "warning-wpcp";
		
		if (smessage !== "" && timeout!=0)
		{
			var smessage_text = smessage;
			jquery_fadeTo();
			document.getElementById("wpcp-error-message").innerHTML = smessage_text;
			document.getElementById("wpcp-error-message").className = "msgmsg-box-wpcp showme " + style;
			clearTimeout(timeout_result);
			timeout_result = setTimeout(hide_message, timeout);
		}
		else
		{
			clearTimeout(timeout_result);
			timeout_result = setTimeout(hide_message, timeout);
		}
	}
	function hide_message()
	{
		jquery_fadeOut();
		document.getElementById("wpcp-error-message").className = "msgmsg-box-wpcp warning-wpcp hideme";
	}
	function jquery_fadeTo()
	{
		try {
			jQuery("#wccp_pro_mask").fadeTo("slow", 0.3);
		}
		catch(err) {
			//alert(err.message);
			}
	}
	function jquery_fadeOut()
	{
		try {
			jQuery("#wccp_pro_mask").fadeOut( "slow" );
		}
		catch(err) {}
	}
	</script>
	<style type="text/css">
	#wccp_pro_mask
	{
		position: absolute;
		bottom: 0;
		left: 0;
		position: fixed;
		right: 0;
		top: 0;
		background-color: #000;
		pointer-events: none;
		display: none;
		z-index: 10000;
		animation: 0.5s ease 0s normal none 1 running ngdialog-fadein;
		background: rgba(0, 0, 0, 0.4) none repeat scroll 0 0;
	}
	#wpcp-error-message {
	    direction: ltr;
	    text-align: center;
	    transition: opacity 900ms ease 0s;
		pointer-events: none;
	    z-index: 99999999;
	}
	.hideme {
    	opacity:0;
    	visibility: hidden;
	}
	.showme {
    	opacity:1;
    	visibility: visible;
	}
	.msgmsg-box-wpcp {
		border-radius: 10px;
		color: <?php echo $wccp_pro_settings['font_color'];?>;
		font-family: Tahoma;
		font-size: <?php echo $wccp_pro_settings['msg_font_size'];?>;
		margin: 10px;
		padding: 10px 36px;
		position: fixed;
		width: 255px;
		top: 50%;
  		left: 50%;
  		margin-top: -10px;
  		margin-left: -130px;
	}
	.msgmsg-box-wpcp b {
		font-weight:bold;
		text-transform:uppercase;
	}
	<?php global $pluginsurl; ?>
	.warning-wpcp {
		background:<?php echo $wccp_pro_settings['msg_color'];?> url('<?php echo $pluginsurl ?>/images/warning.png') no-repeat 10px 50%;
		border:1px solid <?php echo $wccp_pro_settings['shadow_color'];?>;
		-webkit-box-shadow: 0px 0px 34px 2px <?php echo $wccp_pro_settings['shadow_color'];?>;
		-moz-box-shadow: 0px 0px 34px 2px <?php echo $wccp_pro_settings['shadow_color'];?>;
		box-shadow: 0px 0px 34px 2px <?php echo $wccp_pro_settings['shadow_color'];?>;
	}
	.success-wpcp {
		background: #fafafa url('<?php echo $pluginsurl ?>/images/success.png') no-repeat 10px 50%;
		border: 1px solid #00b38f;
		box-shadow: 0px 0px 34px 2px #adc;
	}
    </style>
<?php
}

////////////////////////////////////////////////////////////////////////
function wccp_admin_pro_alert_message()
{
global $wccp_pro_settings;
?>
<div oncontextmenu="return false;" id='wccp_pro_mask'></div>
<div id="wpcp-error-message" class="msgmsg-box-wpcp hideme"><span>error: </span></div>
<script>
	var timeout_result;
	function show_admin_wccp_pro_message(smessage)
	{


		timeout = jQuery("#message_show_time").val()*1000;

		if (smessage !== "" && timeout!=0)
		{
			var smessage_text = smessage;
			jquery_admin_fadeTo();
			document.getElementById("wpcp-error-message").innerHTML = smessage_text;
			document.getElementById("wpcp-error-message").className = "msgmsg-box-wpcp warning-wpcp showme";
			clearTimeout(timeout_result);
			timeout_result = setTimeout(hide_admin_message, timeout);
		}
		else
		{
			clearTimeout(timeout_result);
			timeout_result = setTimeout(hide_admin_message, timeout);
		}

		jQuery(".msgmsg-box-wpcp").css("color", jQuery("input[name='font_color']").val());
		jQuery(".msgmsg-box-wpcp").css("font-size", jQuery("#msg_font_size").val());
		jQuery(".msgmsg-box-wpcp").css("-webkit-box-shadow", "0px 0px 34px 2px "+jQuery("input[name='shadow_color']").val());
		jQuery(".msgmsg-box-wpcp").css("-moz-box-shadow", "0px 0px 34px 2px "+jQuery("input[name='shadow_color']").val());
		jQuery(".msgmsg-box-wpcp").css("box-shadow", "0px 0px 34px 2px "+jQuery("input[name='shadow_color']").val());

		<?php global $pluginsurl; ?>
		jQuery(".warning-wpcp").css("border", "1px solid "+jQuery("input[name='border_color']").val());
		jQuery(".warning-wpcp").css("background",jQuery("input[name='msg_color']").val() +" url('<?php echo $pluginsurl ?>/images/warning.png') no-repeat 10px 50%");

	}
	function hide_admin_message()
	{
		jquery_admin_fadeOut();
		document.getElementById("wpcp-error-message").className = "msgmsg-box-wpcp warning-wpcp hideme";
	}
	function jquery_admin_fadeTo()
	{
		try {
			jQuery("#wccp_pro_mask").fadeTo("slow", 0.3);
		}
		catch(err) {
			//alert(err.message);
		}
	}
	function jquery_admin_fadeOut()
	{
		try {
			jQuery("#wccp_pro_mask").fadeOut( "slow" );
		}
		catch(err) {}
	}
</script>
<style type="text/css">
	#wccp_pro_mask
	{
		position: absolute;
		bottom: 0;
		left: 0;
		position: fixed;
		right: 0;
		top: 0;
		background-color: #000;
		pointer-events: none;
		display: none;
		z-index: 10000;
		animation: 0.5s ease 0s normal none 1 running ngdialog-fadein;
		background: rgba(0, 0, 0, 0.4) none repeat scroll 0 0;
	}
	#wpcp-error-message {
		direction: ltr;
		text-align: center;
		transition: opacity 900ms ease 0s;
		pointer-events: none;
		z-index: 99999999;
	}
	.hideme {
		opacity:0;
		visibility: hidden;
	}
	.showme {
		opacity:1;
		visibility: visible;
	}
	.msgmsg-box-wpcp {
		border-radius: 10px;
		font-family: Tahoma;
		margin: 10px;
		padding: 10px 36px;
		position: fixed;
		width: 255px;
		top: 50%;
		left: 50%;
		margin-top: -10px;
		margin-left: -130px;

	}
	.msgmsg-box-wpcp b {
		font-weight:bold;
		text-transform:uppercase;
	}
</style>
<?php
}
?>