<?php
//---------------------------------------------------------------------------------------------
//Register libraries using new wordpress register_script & enqueue_script functions
//---------------------------------------------------------------------------------------------
$pluginsurl = plugins_url( '', __FILE__ );

$wccp_pro_settings = wccp_pro_read_options();

$c = new wccp_pro_controls_class();

function wccp_pro_enqueue_scripts() {

	global $pluginsurl;
	
	$admincore = '';
	
	if (isset($_GET['page'])) $admincore = $_GET['page'];
	
	if( is_admin() && $admincore == 'wccp-options-pro') {
	
		wp_enqueue_script('jquery');
		
		//wp_register_style('font-awesome.min', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css');
		//wp_enqueue_style('font-awesome.min');
		
		wp_register_style('defaultcss', $pluginsurl.'/css/responsive-pure-css-tabs/default.css');
		wp_enqueue_style('defaultcss');
		
		wp_register_style('stylecss', $pluginsurl.'/css/responsive-pure-css-tabs/style.css?v=4');
		wp_enqueue_style('stylecss');
		
		wp_register_script('responsive_pure_css_tabsjs', $pluginsurl.'/css/responsive-pure-css-tabs/js.js');
		wp_enqueue_script('responsive_pure_css_tabsjs');
		
		if(is_rtl() == 'rtl')
			wp_register_style('bootstrapcss', $pluginsurl.'/bootstrap/css/bootstrap-rtl.min.css');
		else
			wp_register_style('bootstrapcss', $pluginsurl.'/bootstrap/css/bootstrap.min.css');
		wp_enqueue_style('bootstrapcss');
		
		wp_register_script('bootstrap-bundle-min-js', $pluginsurl.'/bootstrap/js/bootstrap.bundle.min.js');
		wp_enqueue_script('bootstrap-bundle-min-js');
		
		wp_enqueue_script( 'wccppro_slimselect', 'https://cdnjs.cloudflare.com/ajax/libs/slim-select/1.25.0/slimselect.min.js','1.0.0',true );
		wp_register_style('wccppro_slimselect_css', 'https://cdnjs.cloudflare.com/ajax/libs/slim-select/1.25.0/slimselect.min.css', false, '1.0.0' );
		wp_enqueue_style('wccppro_slimselect_css');
		
		wp_register_script('image-picker.js', $pluginsurl.'/image-picker/image-picker.js');
		wp_enqueue_script('image-picker.js');
		
		wp_register_style('image-picker.css', $pluginsurl.'/image-picker/image-picker.css');
		wp_enqueue_style('image-picker.css');
		
		wp_register_script('autocomplete-search-js', $pluginsurl.'/js/autocomplete.js',['jquery', 'jquery-ui-autocomplete'], null, true);
        wp_enqueue_script('autocomplete-search-js');
        wp_localize_script('autocomplete-search-js', 'AutocompleteSearch', [
            'ajax_url' => admin_url('admin-ajax.php'),
            'ajax_nonce' => wp_create_nonce('autocompleteSearchNonce')
        ]);
        $wp_scripts = wp_scripts();
        wp_enqueue_style('jquery-ui-css','//ajax.googleapis.com/ajax/libs/jqueryui/' . $wp_scripts->registered['jquery-ui-autocomplete']->ver . '/themes/smoothness/jquery-ui.css',false, null, false);
		
		wp_enqueue_style( 'wp-color-picker' );
		wp_enqueue_script( 'my-script-handle', plugins_url('admin_script.js', __FILE__ ), array( 'wp-color-picker' ), false, true );
		
		wp_enqueue_script('media-upload');
		wp_enqueue_script('thickbox');
		wp_enqueue_media();
	}
	else
	{
		wp_enqueue_script('jquery');
	}
}
add_action('admin_enqueue_scripts', 'wccp_pro_enqueue_scripts');

function wccp_pro_enqueue_front_end_scripts()
{
	global $pluginsurl,$wccp_pro_settings;
	
	wp_enqueue_script('jquery');
	
	if($wccp_pro_settings['prnt_scr_msg'] != '')
	{
		wp_register_style('print-protection.css', $pluginsurl.'/css/print-protection.css');
		wp_enqueue_style('print-protection.css');
	}
}
add_action('wp_enqueue_scripts', 'wccp_pro_enqueue_front_end_scripts');

//------------------------------------------------------------------------
function wpcp_pro_write_to_file_with_markers( $filename, $marker, $insertion ) {
    if (!file_exists( $filename ) || is_writeable( $filename ) ) {
		
		//Clear the file contents
		if($marker == "CLEAR_FILE_CONTENTS")
		{
			file_put_contents( $filename, "" );
			
			return;
		}

		file_put_contents( $filename, "/* BEGIN {$marker} */\n", FILE_APPEND | LOCK_EX );
		if ( is_array( $insertion ))
			foreach ( $insertion as $insertline )
				file_put_contents( $filename, "{$insertline}\n", FILE_APPEND | LOCK_EX );
		file_put_contents( $filename, "/* END {$marker} */\n\n", FILE_APPEND | LOCK_EX );

        return true;
    } else {
        return false;
    }
}

//---------------------------------------------------------------------------------------------
//Add the plugin icon style to the top admin bar
//---------------------------------------------------------------------------------------------
add_action('wp_enqueue_scripts', 'wccp_pro_top_bar_enqueue_style');
add_action('admin_enqueue_scripts', 'wccp_pro_top_bar_enqueue_style');
function wccp_pro_top_bar_enqueue_style() {
    ?>
    <style>
        .pro-wccp:before {
            content: "\f160";
            top: 3px;
        }
        .pro-wccp:before{
            color:#02CA03 !important
        }
        .pro-wccp {
            transform: rotate(45deg);
        }
    </style>
    <?php
}
add_action( 'wp_enqueue_scripts', 'wccp_pro_ajax_enqueue_scripts' );
function wccp_pro_ajax_enqueue_scripts(){
    wp_register_script(
        'wccp_pro_admin_bar_ajax',
        plugins_url('/js/admin_bar_ajax.js', __FILE__),
        array('jquery'),
        false,
        true
    );
    wp_enqueue_script( 'wccp_pro_admin_bar_ajax' );
    wp_localize_script(
        'wccp_pro_admin_bar_ajax',
        'ajax_object',
        array( 'ajaxurl' => admin_url( 'admin-ajax.php' ),'link' => wccp_pro_get_self_url()  )
    );
}
add_action( "wp_ajax_wccp_pro_ajax_top_bar", "wccp_pro_ajax_top_bar" );
add_action( "wp_ajax_nopriv_wccp_pro_ajax_top_bar", "wccp_pro_ajax_top_bar" );
function wccp_pro_ajax_top_bar(){
    $link_add = esc_url_raw($_POST['link']);
    $wccp_pro_settings = wccp_pro_read_options();
    if(empty($wccp_pro_settings['url_exclude_list'])){
        $wccp_pro_settings['url_exclude_list'] = $link_add;
    }else{
        $wccp_pro_settings['url_exclude_list'] = $wccp_pro_settings['url_exclude_list']."\n".$link_add;
    }
    update_blog_option_single_and_multisite( 'wccp_pro_settings' , $wccp_pro_settings );
    wp_die(); // ajax call must die to avoid trailing 0 in your response
}
add_action( "wp_ajax_wccp_pro_ajax_top_bar_remove_Protection", "wccp_pro_ajax_top_bar_remove_Protection" );
add_action( "wp_ajax_nopriv_wccp_pro_ajax_top_bar_remove_Protection", "wccp_pro_ajax_top_bar_remove_Protection" );
function wccp_pro_ajax_top_bar_remove_Protection(){
    $link_add = esc_url_raw($_POST['link']);
    $wccp_pro_settings = wccp_pro_read_options();
    $data = isset($wccp_pro_settings['url_exclude_list'])?$wccp_pro_settings['url_exclude_list']:'';
    $data = str_replace($link_add, "", $data);
    $data = preg_split("/\r\n|\n|\r/", $data);
    $data = array_filter($data, 'strlen');
    $val='';
    foreach ($data as $row){
        $val = $val."\n".$row;
    }
    $wccp_pro_settings['url_exclude_list'] = $val;
    update_blog_option_single_and_multisite( 'wccp_pro_settings' , $wccp_pro_settings );
    wp_die(); // ajax call must die to avoid trailing 0 in your response
}
//---------------------------------------------------------------------------------------------
//Add the plugin icon to the top admin bar
//---------------------------------------------------------------------------------------------
function wpccp_add_items($admin_bar)
{
	global $post;
	$wccpadminurl = get_admin_url();

    $args = array(
        'id'    => 'Protection',
        'title' => '<span class="ab-icon pro-wccp"></span>'.__('Protection' ),
        'href'  => $wccpadminurl.'options-general.php?page=wccp-options-pro',
        'meta'  => array('title' => __('WP Content Copy Protection'),)
    );

    $wccp_pro_settings = wccp_pro_read_options();
    $val = isset($wccp_pro_settings['url_exclude_list'])?$wccp_pro_settings['url_exclude_list']:'';
    $thisLink = wccp_pro_get_self_url();
    $pos = strpos($val, $thisLink);

    //print_r($pos);exit;
    if(!strlen($pos)){
        $sub_args_include = array(
            'id'    => 'WPCCP_Protect',
            'parent' => 'Protection',
            'title' => '<span onclick="wccp_pro_admin_bar_Protection();" style="width: 100%;display: block">'.__('Exclude this page' )."</span>",
            'href'  => "#",
            'meta'  => array('title' => __('WP Content Copy Protection'))
        );
    }else{
        $sub_args_include = array(
            'id'    => 'WPCCP_Protect',
            'parent' => 'Protection',
            'title' => '<span onclick="wccp_pro_admin_bar_remove_Protection();" style="width: 100%;display: block">'.__('Protect This page' )."</span>",
            'href'  => "#",
            'meta'  => array('title' => __('WP Content Copy Protection'))
        );
    }

    $admin_bar->add_menu($args);
    //in front-end pages only
    if(!is_admin()){
        $admin_bar->add_menu($sub_args_include);
    }


	global $wccp_pro_settings;
	if (get_blog_option_single_and_multisite('wccp_pro_settings')) $wccp_pro_settings = get_blog_option_single_and_multisite('wccp_pro_settings'); //To get refreshed array for ajax use

}

if($c -> wccp_pro_get_setting('show_admin_bar_icon') == 'Yes')
{
	add_action('admin_bar_menu', 'wpccp_add_items',  40);
}
//---------------------------------------------------------------------------------------------
//Show settings page
//---------------------------------------------------------------------------------------------
function wccp_pro_options_page_pro()
{	
	if( is_plugin_active( 'wp-content-copy-protector/preventer-index.php' ) )
	{
		echo '<p align="center" dir="ltr">&nbsp;</p>
				<p align="center" dir="ltr">&nbsp;</p>
				<p align="center" dir="ltr">&nbsp;</p>
				<p align="center" dir="ltr"><font size="5" color="#FF0000">Alert!</font></p>
				<p align="center" dir="ltr"><font size="5">The free version of WP Content Copy 
				Protection is still active</font></p>
				<p align="center" dir="ltr"><font size="5">Please deactivate it to start using the pro version</font></p>';
	}
	else
	{
		include 'admin_settings.php';
	}
}

//---------------------------------------------------------------------------------------------
//Make our function to call the WordPress function to add to the correct menu
//---------------------------------------------------------------------------------------------
function wccp_pro_add_options() {

	if(!current_user_can('manage_options')) return; //Premissions checker
	
	add_options_page('WP Content Copy Protection (pro)', 'WP Content Copy Protection (pro)', 'manage_options', 'wccp-options-pro', 'wccp_pro_options_page_pro');
}
add_action('admin_menu', 'wccp_pro_add_options');
?>